#ifndef LIBCLANGEX_CXTYPES_H
#define LIBCLANGEX_CXTYPES_H

#include "clang-c/Platform.h"
#include <stdbool.h>
#include <time.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef void *CXIntrusiveRefCntPtr;

typedef void *CXMemoryBuffer;

// Options
typedef void *CXTargetOptions;
typedef void *CXTargetInfo;
typedef void *CXCodeGenOptions;
typedef void *CXHeaderSearchOptions;
typedef void *CXPreprocessorOptions;
typedef void *CXFrontendOptions;
typedef void *CXLangOptions;

// Sema
typedef void *CXSema;

// Parser
typedef void *CXParser;

// Preprocessor
typedef void *CXPreprocessor;
typedef void *CXHeaderSearch;

typedef enum CXTranslationUnitKind {
  CXTU_Complete,
  CXTU_Prefix,
  CXTU_Module
} CXTranslationUnitKind;

// AST
typedef void *CXASTUnit;
typedef void *CXASTContext;
typedef void *CXASTConsumer;

// CompilerInstance
typedef void *CXCompilerInstance;

// CompilerInvocation
typedef void *CXCompilerInvocation;

// FileManager
typedef void *CXDirectoryEntry;
typedef void *CXFileID;
typedef void *CXFileEntry;
typedef void *CXFileEntryRef; // FIXME: make it a stack value instead of opaque pointer
typedef void *CXFileManager;

// SourceManager
typedef void *CXSourceManager;

// Diagnostic
typedef void *CXDiagnosticIDs;
typedef void *CXDiagnosticOptions;
typedef void *CXDiagnosticConsumer;
typedef void *CXIgnoringDiagConsumer;
typedef void *CXTextDiagnosticPrinter;
typedef void *CXDiagnosticsEngine;

// CodeGen
typedef void *CXCodeGenerator;

#ifdef __cplusplus
}
#endif
#endif